#!/bin/bash

function screensize {
	col=`tput cols`
	row=`tput lines`
	if [[ ${col} -lt "102" ]]
	then
		col=102
	fi
	if [[ ${row} -lt "35" ]]
	then
		row=35
	fi
	printf '\e[8;'${row}';'${col}'t'
}

function initcolors {
	black=$(tput setaf 0)
	red=$(tput setaf 1)
	green=$(tput setaf 2)
	yellow=$(tput setaf 3)
	blue=$(tput setaf 4)
	magenta=$(tput setaf 5)
	cyan=$(tput setaf 6)
	white=$(tput setaf 7)
# Brightened colors
	gray=$(tput setaf 8)
	bred=$(tput setaf 9)
	bgreen=$(tput setaf 10)
	byellow=$(tput setaf 11)
	bblue=$(tput setaf 12)
	bmagenta=$(tput setaf 13)
	bcyan=$(tput setaf 14)
	bwhite=$(tput setaf 15)
# Sets back to normal color
	nc=$(tput sgr0)
}

function titlescreen {
tput clear
#white=$(tput setaf 7)
echo ""
echo ""
echo "${white}"
echo "                                        |__    "
echo "                                        |\/    "
echo "                                        ---    "
echo "                                        / | [  "
echo "                                 !      | |||  "
echo "                               _/|     _/|-++' "
echo "                           +  +--|    |--|--|_ |-  						"
echo "                        { /|__|  |/\__|  |--- |||__/    					"
echo "                       +---------------___[}-_===_.'____                 /\   			"
echo "                   ____ -  ||___-{]_| _[}-  |     |_[___\==--            \/   _  		"
echo "    __..._____--==/___]_|__|_____________________________[___\==--____,------' \  		"
echo "    |                                                                          /  		"
echo "ꕀꕀꕀꕀ\_________________________________________________________________________/ꕀꕀꕀꕀꕀꕀꕀꕀ 	"
echo "													"		
echo "                                                                      				"
echo "                                                                           			"
echo "${gray}"
echo "                                                                           			"
echo "                                     ____                                  			"
echo "                                    /    |                                 			"
echo "                      _____________/     |________________                 			"
echo "        _  __________/                                    \                			"
echo "       (_)/                                                \               			"
echo "        _<                             O      O     O      /              			"
echo "       (_)\_______________________________________________/                			"
echo "         "
echo " ${bblue} "
echo "				"
echo "      												"
tput cup 15 0
echo "${cyan}ꕀꕀꕀꕀ"
tput cup 15 79
echo "ꕀꕀꕀꕀꕀꕀꕀꕀ"


#29,0
S1="⠀МОРСКОЙ БОЙ"
for t in {1..55}
do
	tput cup 29 $t
	echo "$S1"
	rest 75
done
echo "${nc}"
tput cup 31 50
read -n 1 -s -r -p "Нажмите любую клавишу для продолжения"
}

function rest {
# parameter value sent is in milliseconds, 1000 is 1 second
t1=$1
start=$(date +%s%N)
end=$(date +%s%N)
while [[ $((($(date +%s%N) - $start)/1000000)) -le ${t1} ]]
do	
	 ((count+=1))
done	
}

function instructions {
	tput clear
	tput cup 5 0
	echo " Есть 5 вражеских кораблей, которые нужно потопить, прежде чем враг потопит ваши корабли.	"
	echo " "
	echo " Эти пять кораблей - это: "
	echo " " 
	echo " Перевозчик    (5)	- ${cyan} █████ ${nc}	"
	echo " Военный корабль (4)	- ${cyan} ████ ${nc}	"
	echo " Крейсер    (3)	- ${cyan} ███ ${nc}	"
	echo " Подводная лодка  (3)	- ${cyan} ███ ${nc}	"
	echo " Разрушитель  (2)	- ${cyan} ██ ${nc}	"
	echo " "
	echo " У вас будет сетка размером 10 на 10 квадратов."
	echo " Квадраты помечены от A до J для столбцов и от 1 до 0 (10) для строк."
	echo " В свою очередь, вам нужно будет ввести значение столбца (A-J)."
	echo " После нажатия клавиши Enter вам будет предложено ввести строку (1-0)."
	echo " Если квадрат уже был выбран, вам будет предложено сделать другой выбор."
	echo " При вводе квадратов будут допускаться только действительные записи."
	echo " "
	echo " Нажмите X в любом приглашении, чтобы выйти из игры."
	echo " Когда вы сделаете выбор, вам сообщат, была ли ваша догадка верной или нет."
	echo " Если произойдет попадание, то в выбранном месте появится красный квадрат, в противном случае он будет белым."
	echo " Вам также сообщат, какое судно пострадало".
	echo " Как только корабль будет потоплен, его название на доске будет таким: ${red}красный${nc}."
	tput cup 31 50
	read -n 1 -s -r -p "Нажмите любую клавишу для продолжения"
}

function initgridarray {
	for i in {0..10}
	do
		for j in {0..10}
		do
			((k=(${i}*10)+j))
			ugrid[${k}]="0"
			pgrid[${k}]="0"
			shoot[${k}]="0"
		done
	done
	# User's boats
	ucarrier=1
	ubattleship=1
	ucruiser=1
	usubmarine=1
	udestroyer=1
	# PC's boats
	pcarrier=1
	pbattleship=1
	pcruiser=1
	psubmarine=1
	pdestroyer=1
}

function initgridview {
# draw out the initial grid

tput clear
echo "${bblue}"
echo "         Ваши корабли    			               Вражеские корабли"
echo " ${nc}   A B C D E F G H I J 				    A B C D E F G H I J  "
echo "   ┌─┬─┬─┬─┬─┬─┬─┬─┬─┬─┐ 				   ┌─┬─┬─┬─┬─┬─┬─┬─┬─┬─┐ "
echo " 1 │ │ │ │ │ │ │ │ │ │ │ 				 1 │ │ │ │ │ │ │ │ │ │ │ "
echo "   ├─┼─┼─┼─┼─┼─┼─┼─┼─┼─┤ 				   ├─┼─┼─┼─┼─┼─┼─┼─┼─┼─┤ "
echo " 2 │ │ │ │ │ │ │ │ │ │ │ 				 2 │ │ │ │ │ │ │ │ │ │ │ "
echo "   ├─┼─┼─┼─┼─┼─┼─┼─┼─┼─┤ 				   ├─┼─┼─┼─┼─┼─┼─┼─┼─┼─┤ "
echo " 3 │ │ │ │ │ │ │ │ │ │ │ 				 3 │ │ │ │ │ │ │ │ │ │ │ "
echo "   ├─┼─┼─┼─┼─┼─┼─┼─┼─┼─┤ 				   ├─┼─┼─┼─┼─┼─┼─┼─┼─┼─┤ "
echo " 4 │ │ │ │ │ │ │ │ │ │ │ 				 4 │ │ │ │ │ │ │ │ │ │ │ "
echo "   ├─┼─┼─┼─┼─┼─┼─┼─┼─┼─┤ 				   ├─┼─┼─┼─┼─┼─┼─┼─┼─┼─┤ "
echo " 5 │ │ │ │ │ │ │ │ │ │ │ 				 5 │ │ │ │ │ │ │ │ │ │ │ "
echo "   ├─┼─┼─┼─┼─┼─┼─┼─┼─┼─┤ 				   ├─┼─┼─┼─┼─┼─┼─┼─┼─┼─┤ "
echo " 6 │ │ │ │ │ │ │ │ │ │ │ 				 6 │ │ │ │ │ │ │ │ │ │ │ "
echo "   ├─┼─┼─┼─┼─┼─┼─┼─┼─┼─┤ 				   ├─┼─┼─┼─┼─┼─┼─┼─┼─┼─┤ "
echo " 7 │ │ │ │ │ │ │ │ │ │ │ 				 7 │ │ │ │ │ │ │ │ │ │ │ "
echo "   ├─┼─┼─┼─┼─┼─┼─┼─┼─┼─┤ 				   ├─┼─┼─┼─┼─┼─┼─┼─┼─┼─┤ "
echo " 8 │ │ │ │ │ │ │ │ │ │ │ 				 8 │ │ │ │ │ │ │ │ │ │ │ "
echo "   ├─┼─┼─┼─┼─┼─┼─┼─┼─┼─┤ 				   ├─┼─┼─┼─┼─┼─┼─┼─┼─┼─┤ "
echo " 9 │ │ │ │ │ │ │ │ │ │ │ 				 9 │ │ │ │ │ │ │ │ │ │ │ "
echo "   ├─┼─┼─┼─┼─┼─┼─┼─┼─┼─┤ 				   ├─┼─┼─┼─┼─┼─┼─┼─┼─┼─┤ "
echo " 0 │ │ │ │ │ │ │ │ │ │ │ 				 0 │ │ │ │ │ │ │ │ │ │ │ "
echo "   └─┴─┴─┴─┴─┴─┴─┴─┴─┴─┘ 				   └─┴─┴─┴─┴─┴─┴─┴─┴─┴─┘ "
for x1 in {1..10}
do
	for y1 in {1..10}
	do
# check user grid
		((k3=(${y1}*10)+${x1}))
		k4=${ugrid[${k3}]}
		placex=$(( ( ${x1}*2 ) +2 ))
		placey=$(( ( ${y1}*2 ) +2 ))
		if [[ ${k4} -ge 1 ]] && [[ ${k4} -le 5 ]]	# boat
		then
			echo "${blue}"
			tput cup ${placey} ${placex}
			echo "█"
		elif [[ ${k4} -eq 9 ]]				# hit
		then
			echo "${red}"
			tput cup ${placey} ${placex}
			echo "█"
		elif [[ ${k4} -eq 8 ]]				# miss
		then
			echo "${white}"
			tput cup ${placey} ${placex}
			echo "█"
		fi
# check pc grid
		((k3=(${y1}*10)+${x1}))
		k4=${pgrid[${k3}]}
		placex=$(( ( ${x1}*2 ) +58 ))
		placey=$(( ( ${y1}*2 ) +2 ))
		if [[ ${k4} -eq 9 ]]				# hit
		then			
			echo "${red}"
			tput cup ${placey} ${placex}
			echo "█"
		elif [[ ${k4} -eq 8 ]]				# miss
		then
			echo "${white}"
			tput cup ${placey} ${placex}
			echo "█"
		fi
	done
done

echo "${nc}"
}

function showplacegrid {

tput clear
echo "${bblue}"
echo "      Разместите Свои Корабли     	"
echo " ${nc}   A B C D E F G H I J "
echo "   ┌─┬─┬─┬─┬─┬─┬─┬─┬─┬─┐  "
echo " 1 │ │ │ │ │ │ │ │ │ │ │ 	"
echo "   ├─┼─┼─┼─┼─┼─┼─┼─┼─┼─┤ 	"
echo " 2 │ │ │ │ │ │ │ │ │ │ │ 	"
echo "   ├─┼─┼─┼─┼─┼─┼─┼─┼─┼─┤ 	"
echo " 3 │ │ │ │ │ │ │ │ │ │ │ 	"
echo "   ├─┼─┼─┼─┼─┼─┼─┼─┼─┼─┤ 	"
echo " 4 │ │ │ │ │ │ │ │ │ │ │ 	"
echo "   ├─┼─┼─┼─┼─┼─┼─┼─┼─┼─┤ 	"
echo " 5 │ │ │ │ │ │ │ │ │ │ │ 	"
echo "   ├─┼─┼─┼─┼─┼─┼─┼─┼─┼─┤ 	"
echo " 6 │ │ │ │ │ │ │ │ │ │ │ 	"
echo "   ├─┼─┼─┼─┼─┼─┼─┼─┼─┼─┤ 	"
echo " 7 │ │ │ │ │ │ │ │ │ │ │ 	"
echo "   ├─┼─┼─┼─┼─┼─┼─┼─┼─┼─┤ 	"
echo " 8 │ │ │ │ │ │ │ │ │ │ │ 	"
echo "   ├─┼─┼─┼─┼─┼─┼─┼─┼─┼─┤ 	"
echo " 9 │ │ │ │ │ │ │ │ │ │ │ 	"
echo "   ├─┼─┼─┼─┼─┼─┼─┼─┼─┼─┤ 	"
echo " 0 │ │ │ │ │ │ │ │ │ │ │ 	"
echo "   └─┴─┴─┴─┴─┴─┴─┴─┴─┴─┘ 	"
tput cup 26 5
echo ${message1} 
echo ${message2}
echo "${red}"
for x1 in {1..10}
do
	for y1 in {1..10}
	do
		((k3=(${y1}*10)+${x1}))
		k4=${ugrid[${k3}]}
		if [[ ${k4} -ge 1 ]]
		then
			placex=$(( ( ${x1}*2 ) +2 ))
			placey=$(( ( ${y1}*2 ) +2 ))
			tput cup ${placey} ${placex}
			echo "█"
		fi
	done
done
echo "${nc}"
}

function placeships {
# Let's the user place their ships
	showplacegrid
	place=1
	message1="Перевозчик места (5)"
	message2="     Используйте цифровую клавиатуру для перемещения, 5 для переворота и "Р" для размещения."
	tput cup 26 5
	echo ${message1} 
	echo ${message2}
	key="A"
	done=5
	maxx=4
	maxy=0
	max=5
	x=1
	y=1
	orient="H"
	instr="24685PX"
	while [[ ${done} -gt "0" ]]
	do
		redraw
		read -n1 -r -s key
		key=${key^^}
		# check user's input for validity
		if [[ $instr == *"$key"* ]]
		then
			# input is valid
			tput cup 28 1
			case ${key} in
			X)  # Exit
				tput clear
				echo "Спасибо за игру!                      "
				tput cnorm
		    		exit 0;;
			2)  # Down
				((y+=1))
				if [[ ${y}+${maxy} -ge 11 ]]
				then
					((y-=1))
				fi
				redraw;;
			4) # Left
				((x-=1))
				if [[ ${x} -lt 1 ]]
				then
					((x=1))
				fi
				redraw;; 
			5) # Flip
				if [[ ${orient} == "H" ]]
				then
					orient="V"
					temp=${maxx}
					maxx=${maxy}
					maxy=${temp}
					if [[ ${y}+${maxy} -ge 11 ]]
					then
						y=10-${maxy}
					fi
				else
					orient="H"
					temp=${maxx}
					maxx=${maxy}
					maxy=${temp}
					if [[ ${x}+${maxx} -ge 11 ]]
					then
						x=10-${maxx}
					fi
				redraw
				fi;;				
			6) # Right
				((x+=1))
				if [[ ${x}+${maxx} -ge 11 ]]
				then
					((x-=1))
				fi
				redraw;;
			8) # Up
				((y-=1))
				if [[ ${y} -lt 1 ]]
				then
					((y=1))
				fi
				redraw;;
			P) # Place
			 	# logic to place ship
				placex=${x}
				placey=${y}
				# verify that the ship is not on top of another ship
				verify=0
				if [[ $orient == "H" ]]
				then
					for times in $( eval echo {1..$max} )
					do
						((k3=(((${placey}*10)+${placex}))))
						k4=${ugrid[${k3}]}
						if [[ ${k4} -ge 1 ]]
						then
							verify=1
						fi
						((placex=${placex}+1))
					done
				else
					for times in $( eval echo {1..$max} )
					do
						((k3=(((${placey}*10)+${placex}))))
						k4=${ugrid[${k3}]}
						if [[ ${k4} -ge 1 ]]
						then
							verify=1
						fi
						((placey+=1))
					done
				fi
				
				if [[ ${verify} == "0" ]]
				then
				 	placex=${x}
					placey=${y}
				 	if [[ $orient == "H" ]]
					then
						for times in $( eval echo {1..$max} )
						do
							((k3=(((${placey}*10)+${placex}))))
							ugrid[${k3}]=${done}
							((placex=${placex}+1))
						done
					else
						for times in $( eval echo {1..$max} )
						do
							((k3=(((${placey}*10)+${placex}))))
							ugrid[${k3}]=${done}
							((placey+=1))
						done
					fi
				 	((place+=1))
				 	orient="H"
				 	x=1
				 	y=1
				 	case ${place} in
				 		2) # BattleShip (4)
							message1=" (4)            "
							echo ${message1}
							maxx=3
							maxy=0
							done=4
							max=4;;
					 	3) # Cruise (3)
					 		message1="Place Cruiser (3)               "
					 		echo ${message1}
					 		maxx=2
					 		maxy=0
					 		done=3
					 		max=3;;
					 	4) # Submarine (3)
						 	message1="Place Submarine (3)             "
						 	echo ${message1}
						 	maxx=2
						 	maxy=0
						 	done=2
						 	max=3;;             
					 	5) # Destroyer (2)
						 	message1="Place Destroyer (2)             "
						 	echo ${message1}
						 	maxx=1
						 	maxy=0
						 	done=1
						 	max=2;;
					 	6) # Done placing ships
					 		message1=""
					 		message2=""
					 		echo ${message1}
					 		done=0;;
				 	esac
					redraw
				fi		
			esac
		else
			## input is not valid
			valid=0
			tput cup 28 1
			echo "${red}**** Неверный выбор! *******${nc}"
		fi
	done
	x=0
	y=0
	max=0
}

function placepcships {
# let the PC randomly place ships
for ship in {5..1}
do
	tput cup 30 1
	echo "                                 "
	tput cup 30 1
	case ${ship} in
		5) # Carrier (5)
			message1="PC is place Carrier                   "
			echo ${message1}
			max=5;;
		4) # BattleShip (4)
			message1="PC is placing Battleship              "
			echo ${message1}
			max=4;;
		3) # Cruise (3)
			message1="PC is placing Cruiser                  "
			echo ${message1}
			max=3;;
		2) # Submarine (3)
		 	message1="PC is placing Submarine                "
		 	echo ${message1}
		 	max=3;;             
		1) # Destroyer (2)
		 	message1="PC is placing Destroyer                 "
		 	echo ${message1}
		 	max=2;;
 	esac
 	placed=0
 	((length=${max}))
 	while [[ ${placed} -eq 0 ]]
 	do
 		a=$(( ( SRANDOM %100 ) + 1 ))
 		((max1=10-${max}+1))
 		if [[ ${a} -le 50 ]]
 		then
	 		orient="H"
	 		x=$(( ( SRANDOM %${max1} ) + 1 ))
	 		y=$(( ( SRANDOM %10 ) + 1 ))
	 		xtemp=${x}
	 		ytemp=${y}
	 		skip=0
	 		for times in $( eval echo {1..${length}} )
	 		do
	 			((k3=(${y}*10)+${x}))
	 			if [[ ${pgrid[${k3}]} -ge 1 ]] && [[ ${pgrid[${k3}]} -le 5 ]]
	 			then
	 				skip=1
	 			fi
	 			((x+=1))
	 		done
	 	else
	 		orient="V"
	 		x=$(( ( SRANDOM %10 ) + 1 ))
	 		y=$(( ( SRANDOM %${max1} ) + 1 ))
	 		xtemp=${x}
	 		ytemp=${y}
	 		skip=0
	 		for times in $( eval echo {1..${length}} )
	 		do
	 			((k3=(${y}*10)+${x}))
	 			if [[ ${pgrid[${k3}]} -ge 1 ]] && [[ ${pgrid[${k3}]} -le 5 ]]
	 			then
	 				skip=1
	 			fi
	 			((y+=1))
	 		done
 		fi
 		if [[ ${skip} -eq 0 ]]
 		then
 			placed=1
 		fi	
 	done
 	# change values on pgrid starting at y1 x1
 	x=${xtemp}
	y=${ytemp}
	if [[ ${orient} == "H" ]]
	then
 		for times in $( eval echo {1..${length}} )
 		do
 			((k3=(${y}*10)+${x}))
 			pgrid[${k3}]=${ship}
 			((x+=1))
 		done
 	else
 		for times in $( eval echo {1..${length}} )
 		do
 			((k3=(${y}*10)+${x}))
 			pgrid[${k3}]=${ship}
 			((y+=1))
 		done
	fi
sleep 1s
done
}

function showugrid {
p1=2
tput cup 30 1
for count1 in {1..10}
do
	((p1+=1))
	p2=60
	for count2 in {1..10}
	do
		((p2+=2))
		tput cup ${p1} ${p2}
		# echo "${ugrid[${count1},${count2}]}
		((k3=(${count1}*10)+${count2}))
		p3=${ugrid[${k3}]}
		echo "${p3} "
	done
done
}

function checkwin {
found=0
for count1 in {1..10}
do
	for count2 in {1..10}
	do
		((k3=(${count1}*10)+${count2}))
		p3=${pgrid[${k3}]}
		if [[ ${p3} -ge 1 ]] && [[ ${p3} -le 5 ]]
		then
			found=1
			break 2
		fi 
	done
done
if [[ ${found} -eq 0 ]]
then
	winner=1	# User Wins
	tput clear
	tput cup 30 1
	echo "Ты Победил!                                  "
	exit 0
fi
for boat in {1..5}
do
	found=0
	for count1 in {1..10}
	do
		for count2 in {1..10}
		do
			((k3=(${count1}*10)+${count2}))
			p3=${pgrid[${k3}]}
			if [[ ${p3} -eq ${boat} ]]
			then
				found=1
				break 2
			fi 
		done
	done
	if [[ ${found} -eq 0 ]]
	then
		case ${boat} in
		5)
			if [[ ${pcarrier} -eq 1 ]]
			then
				tput cup 30 1
				echo "Player sank PC's Carrier!"
				pcarrier=0
				sleep 2s
			fi;;
		4)
			if [[ ${pbattleship} -eq 1 ]]
			then
				tput cup 30 1
				echo "Player sank PC's Battleship!                       "
				pbattleship=0
				sleep 2s
			fi;;
		3)
			if [[ ${pcruiser} -eq 1 ]]
			then
				tput cup 30 1
				echo "Player sank PC's Cruiser!                       "
				pcruiser=0
				sleep 2s
			fi;;
		2)
			if [[ ${psubmarine} -eq 1 ]]
			then
				tput cup 30 1
				echo "Player sank PC's Submarine!                       "
				psubmarine=0
				sleep 2s
			fi;;
		1)
			if [[ ${pdestroyer} -eq 1 ]]
			then
				tput cup 30 1
				echo "Игрок потопил компьютерный эсминец!                       "
				pdestroyer=0
				sleep 2s
			fi;;
		esac
	fi
done
found=0
for count1 in {1..10}
do
	for count2 in {1..10}
	do
		((k3=(${count1}*10)+${count2}))
		p3=${ugrid[${k3}]}
		if [[ ${p3} -ge 1 ]] && [[ ${p3} -le 5 ]]
		then
			found=1
			break 2
		fi 
	done
done
if [[ ${found} -eq 0 ]]
then
	winner=2	# PC Wins
	tput clear
	tput cup 30 1
	echo "Компьютер побеждает!                                  "
	exit 0
fi
for boat in {1..5}
do
	found=0
	for count1 in {1..10}
	do
		for count2 in {1..10}
		do
			((k3=(${count1}*10)+${count2}))
			p3=${ugrid[${k3}]}
			if [[ ${p3} -eq ${boat} ]]
			then
				found=1
				break 2
			fi 
		done
	done
	if [[ ${found} -eq 0 ]]
	then
		case ${boat} in
		5)
			if [[ ${ucarrier} -eq 1  ]]
			then
				tput cup 30 1
				echo "ПК потопил носитель игрока!                       "
				ucarrier=0
				sleep 2s
			fi;;
		4)
			if [[ ${ubattleship} -eq 1  ]]
			then
				tput cup 30 1
				echo "ПК потопил боевой корабль игрока!                       "
				ubattleship=0
				sleep 2s
			fi;;
		3)
		if [[ ${ucruiser} -eq 1  ]]
			then
				tput cup 30 1
				echo "ПК потопил крейсер игрока!                       "
				ucruiser=0
				sleep 2s
			fi;;
		2)
		if [[ ${usubmarine} -eq 1  ]]
			then
				tput cup 30 1
				echo "ПК потопил подводную лодку игрока!                       "
				usubmarine=0
				sleep 2s
			fi;;
		1)
		if [[ ${udestroyer} -eq 1  ]]
			then
				tput cup 30 1
				echo "ПК потопил эсминец игрока!                       "
				udestroyer=0
				sleep 2s
			fi;;
		esac
	fi
done
# show any sank ships
if [[ ${ucarrier} -eq 1 ]]
then
	echo "${white}"
else
	echo "${red}"
fi
tput cup 12 25
echo "Перевозчик${nc}"
if [[ ${ubattleship} -eq 1 ]]
then
	echo "${white}"
else
	echo "${red}"
fi
tput cup 13 25
echo "Военный корабль${nc}"
if [[ ${ucruiser} -eq 1 ]]
then
	echo "${white}"
else
	echo "${red}"
fi
tput cup 14 25
echo "Перевозчик${nc}"
if [[ ${usubmarine} -eq 1 ]]
then
	echo "${white}"
else
	echo "${red}"
fi
tput cup 15 25
echo "Подводная лодка${nc}"
if [[ ${udestroyer} -eq 1 ]]
then
	echo "${white}"
else
	echo "${red}"
fi
tput cup 16 25
echo "Разрушитель${nc}"
# show sunk ships for PC
if [[ ${pcarrier} -eq 1 ]]
then
	echo "${white}"
else
	echo "${red}"
fi
tput cup 12 81
echo "Перевозчик${nc}"
if [[ ${pbattleship} -eq 1 ]]
then
	echo "${white}"
else
	echo "${red}"
fi
tput cup 13 81
echo "Военный корабль${nc}"
if [[ ${pcruiser} -eq 1 ]]
then
	echo "${white}"
else
	echo "${red}"
fi
tput cup 14 81
echo "Крейсер${nc}"
if [[ ${psubmarine} -eq 1 ]]
then
	echo "${white}"
else
	echo "${red}"
fi
tput cup 15 81
echo "Подводная лодка${nc}"
if [[ ${pdestroyer} -eq 1 ]]
then
	echo "${white}"
else
	echo "${red}"
fi
tput cup 16 81
echo "Разрушитель${nc}"
}

function redraw {
	showplacegrid
	placex=$(( ( ${x}*2 ) +2 ))
	placey=$(( ( ${y}*2 ) +2 ))
	tput cup ${placey} ${placex}
	echo "${blue}█${nc}"
	if [[ $orient == "H" ]]
	then
		for times in $( eval echo {2..$max} )
		do
			((placex=${placex}+2))
			tput cup ${placey} ${placex}
			echo "${blue}█${nc}"
		done
	else
		for times in $( eval echo {2..$max} )
		do
			((placey=${placey}+2))
			tput cup ${placey} ${placex}
			echo "${blue}█${nc}"		
		done
	fi
	
}

function getuserinput {
valid=0
while [[ ${valid} -eq 0 ]]
do
	instr="ABCDEFGHIJX"
	colvalid=0
	while [[ ${colvalid} -eq 0 ]]
	do
		tput cup 30 1
		echo "                                                  "
		tput cup 30 1
		echo "Введите столбец для выбора (A-J)(X для выхода):                "
		read -n1 -r -s col
		col=${col^^}
		# check user's input for validity
		if [[ $instr == *"$col"* ]]
		then 
			colvalid=1
			case ${col} in
			A) 
				x1=1;;
			B) 
				x1=2;;
			C) 
				x1=3;;
			D) 
				x1=4;;
			E) 
				x1=5;;
			F) 
				x1=6;;
			G) 
				x1=7;;
			H) 
				x1=8;;
			I) 
				x1=9;;
			J) 
				x1=10;;
			X)
				tput clear
				echo "Спасибо за игру!                      "
				tput cnorm
	    			exit 0;;
			esac
		fi
	done
	instr="0123456789"
	#x1=${col}
	rowvalid=0
	while [[ ${rowvalid} -eq 0 ]]
	do
		tput cup 30 1
		echo "                                                  "
		tput cup 30 1
		echo "Введите строку для выбора (1-0):                "
		read -n1 -r -s row
		y1=${row}
		# check user's input for validity
		if [[ $instr == *"$row"* ]]
		then 
			rowvalid=1
		fi
		if [[ ${row} -eq 0 ]]
		then
			row=10
			y1=10
		fi
	done
	((k3=(${y1}*10)+${x1}))
	k4=${pgrid[${k3}]}
	if [[ ${k4} -lt 8 ]] # not a hit or miss that was already chosen
	then
		if [[ ${k4} -eq 0 ]]
		then
			# miss
			pgrid[${k3}]=8
			tput cup 30 1
			echo "Ты промахнулся!                                              "
			sleep 2s
			valid=1
		else
			case ${k4} in
				1)
					ship="Разрушитель";;
				2)
					ship="Подводная лодка";;
				3)
					ship="Крейсер";;
				4)
					ship="Военный корабль";;
				5)
					ship="Перевозчик";;
			esac
			pgrid[${k3}]=9
			tput cup 30 1
			echo "Ты ударил меня ${ship}!                                      "
			sleep 2s
			valid=1
		fi
	fi
done
}

function getpcinput {
valid=0
while [[ ${valid} -eq 0 ]]
do
	colvalid=0
	while [[ ${colvalid} -eq 0 ]]
	do
		x=$(( ( SRANDOM %10 ) + 1 ))
	 	row=$(( ( SRANDOM %10 ) + 1 ))
	 	case ${x} in
	 		1)
	 			col="A";;
	 		2)
	 			col="B";;
	 		3)
	 			col="C";;
	 		4)
	 			col="D";;
	 		5)
	 			col="E";;
	 		6)
	 			col="F";;
	 		7)
	 			col="G";;
	 		8)
	 			col="H";;
	 		9)
	 			col="I";;
	 		0)
	 			col="J";;
	 	esac
		tput cup 30 1
		echo "                                                  "
		tput cup 30 1
		echo "ПК выбирает: ${col} ${row}                         "
		# check pc's input for validity
		colvalid=1
		x1=${x}
	done
	y1=${row}
	((k3=(${y1}*10)+${x1}))
	k4=${ugrid[${k3}]}
	if [[ ${k4} -lt 8 ]] # not a hit or miss that was already chosen
	then
		if [[ ${k4} -eq 0 ]]
		then
			# miss
			ugrid[${k3}]=8
			tput cup 31 1
			echo "КОМПЬЮТЕР пропущен!                                              "
			sleep 2s
			valid=1
		else
			case ${k4} in
				1)
					ship="Разрушитель";;
				2)
					ship="Подводная лодка";;
				3)
					ship="Крейсер";;
				4)
					ship="Военный корабль";;
				5)
					ship="Перевозчик";;
			esac
			ugrid[${k3}]=9
			tput cup 31 1
			echo "КОМПЬЮТЕР поразил ваш ${ship}!                                      "
			sleep 2s
			valid=1
		fi
	fi
	tput cup 30 1 
	echo "                                                         "
	tput cup 31 1
	echo "                                                          "
done
}

asciiconv() {
# takes charactean ASCII numeric value and returns it back to the calling command
	val=printf '%d\n' "'$1"
	echo "$val"
}

declare -A ugrid	# User's grid
declare -A pgrid	# PC's grid
declare -A shoot	# PC's grid for logic to shoot
declare -i x
declare -i y 
declare -i max
declare -i winner	# 1 if user wins and 2 if PC wins
declare -u orient	

# size needs to be at least 102x35
tput civis	# make cursor invisible
screensize	# set screen size
initcolors	# initialize colors for echo
titlescreen    # show title screen   
instructions   # show instructions   
initgridarray	# display initial screen
placeships	# allow user to place their ships in the grid
initgridview	# show grid with placed boats
placepcships	# let PC randomly place ships
initgridview	# show grid with placed boats
checkwin	# must call checkwin to show that no ships are sunk yet
winner=0
while [[ ${winner} -eq 0 ]]
do
	getuserinput	# let user choose a spot to strike
	initgridview	# redraw the screen
	checkwin	# check is there is a winner
	getpcinput	# let PC make a choice to strike
	initgridview	# redraw the screen
	checkwin	# check is there is a winner
done
tput cnorm  		# make cursor visible

